﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication15
{
    public partial class Form1 : Form
    {


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (char c = 'A'; c <= 'D'; c++)
            {
                var row = this.ultraDataSource1.Rows.Add(new object[] { c.ToString() });
                row.GetChildRows(0).Add(new object[] { c.ToString() + "1"});
                row.GetChildRows(0).Add(new object[] { c.ToString() + "2" });
            }

            this.ultraGrid1.Rows[1].Expanded = true;
            this.ultraGrid1.Rows[3].Expanded = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string fileName = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xlsx");
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, fileName);
            Process.Start(fileName);
        }

        // Use these to record where there are expanded rows at the root level. 
        int? startIndex = null;
        List<RowExpansionInfo> rowExpansionInfos = new List<RowExpansionInfo>();

        private void ultraGridExcelExporter1_RowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventArgs e)
        {
            if (e.GridRow.Band.Index == 0)
            {
                // If the row is expanded
                if (e.GridRow.Expanded)
                {
                    // If the row is expanded, record the index at which it was exported. 
                    startIndex = e.CurrentRowIndex - 1;
                }
                else if (startIndex.HasValue)
                {
                    // If the row is collapsed, record the ending index, so we know where to stop. 
                    rowExpansionInfos.Add(new RowExpansionInfo(startIndex.Value, e.CurrentRowIndex - 1));
                    startIndex = null;
                }
            }
        }        

        private void ultraGridExcelExporter1_ExportEnding(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndingEventArgs e)
        {
            // If the last row was expanded, we need to record the ending index here. 
            if (startIndex.HasValue)
            {
                rowExpansionInfos.Add(new RowExpansionInfo(startIndex.Value, e.CurrentRowIndex));
                startIndex = null;
            }

            // Loop through the recorded info and un-hide any hidden rows that should
            // be under an expanded parent. 
            foreach (var rowExpansionInfo in this.rowExpansionInfos)
            {
                for (int i = rowExpansionInfo.StartIndex; i <= rowExpansionInfo.EndIndex; i++)
                {
                    e.CurrentWorksheet.Rows[i].Hidden = false;
                }
            }
        }

        internal struct RowExpansionInfo
        {
            private int startIndex;
            private int endIndex;

            internal RowExpansionInfo(int startIndex, int endIndex)
            {
                this.startIndex = startIndex;
                this.endIndex = endIndex;
            }

            public int StartIndex
            {
                get
                {
                    return startIndex;
                }
            }

            public int EndIndex
            {
                get
                {
                    return endIndex;
                }
            }

          
        }

       
    }    
}
